source(Utils.getFilename("ReversingCamera.lua", g_currentModDirectory))

ReversingCamera_register = {}

function ReversingCamera_register:loadMap()
end

function ReversingCamera_register:register(name) 
	if g_specializationManager:getSpecializationByName("ReversingCamera") == nil then
	  if ReversingCamera == nil then 
		print("ERROR: unable to add specialization 'ReversingCamera'")
	  else 
		for i, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
			if typeDef ~= nil and i ~= "locomotive" and i ~= "trainTrailer" and i ~= "trainTimberTrailer" then 
				local isDrivable = false
				local isEnterable = false 
				local isanimatedVehicle = false 
				for name, spec in pairs(typeDef.specializationsByName) do
					if name == "drivable"  then 
						isDrivable = true 
					elseif name == "enterable" then 
						isEnterable = true 
					elseif name == "animatedVehicle" then 
						isanimatedVehicle = true 
					end 
				end 
				if isDrivable and isEnterable and isanimatedVehicle then
				  typeDef.specializationsByName["ReversingCamera"] = ReversingCamera
				  table.insert(typeDef.specializationNames, "ReversingCamera")
				  table.insert(typeDef.specializations, ReversingCamera)  
				end 
			end 
		end   
	  end 
	end
end 
VehicleTypeManager.finalizeVehicleTypes = Utils.prependedFunction(VehicleTypeManager.finalizeVehicleTypes, ReversingCamera_register.register) 
print("----ReversingCamera registered.")

addModEventListener(ReversingCamera_register);